Package com.io7m.jtensors.core.unparameterized.vectors

# Class Vector3I

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector3I

All Implemented Interfaces:
  `Vector3IType`, `VectorReadable2IType`, `VectorReadable3IType`, `VectorComputationalType`

public final class Vector3I extends Object implements Vector3IType
The type of 3D `int`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `Vector3I.Builder`
  Builds instances of type `Vector3I`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Vector3I.Builder`
  `builder()`
  Creates a builder for `Vector3I`.
  `static Vector3I`
  `copyOf(Vector3IType instance)`
  Creates an immutable copy of a `Vector3IType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `Vector3I` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`, `z`.
  `static Vector3I`
  `of(int x, int y, int z)`
  Construct a new immutable `Vector3I` instance.
  `String`
  `toString()`
  Prints the immutable value `Vector3I` with attribute values.
  `final Vector3I`
  `withX(int value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final Vector3I`
  `withY(int value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `final Vector3I`
  `withZ(int value)`
  Copy the current immutable object by setting a value for the `z` attribute.
  `int`
  `x()`
  `int`
  `y()`
  `int`
  `z()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public int x()
    Specified by:
      `x` in interface `Vector3IType`
    Specified by:
      `x` in interface `VectorReadable2IType`
    Returns:
      The value of the `x` attribute

  - ### y

    public int y()
    Specified by:
      `y` in interface `Vector3IType`
    Specified by:
      `y` in interface `VectorReadable2IType`
    Returns:
      The value of the `y` attribute

  - ### z

    public int z()
    Specified by:
      `z` in interface `Vector3IType`
    Specified by:
      `z` in interface `VectorReadable3IType`
    Returns:
      The value of the `z` attribute

  - ### withX

    public final Vector3I withX(int value)
    Copy the current immutable object by setting a value for the `x` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final Vector3I withY(int value)
    Copy the current immutable object by setting a value for the `y` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### withZ

    public final Vector3I withZ(int value)
    Copy the current immutable object by setting a value for the `z` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `Vector3I` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `Vector3I` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static Vector3I of(int x, int y, int z)
    Construct a new immutable `Vector3I` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
    Returns:
      An immutable Vector3I instance

  - ### copyOf

    public static Vector3I copyOf(Vector3IType instance)
    Creates an immutable copy of a `Vector3IType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Vector3I instance

  - ### builder

    public static Vector3I.Builder builder()
    Creates a builder for `Vector3I`.

         Vector3I.builder()
            .setX(int) // required x
            .setY(int) // required y
            .setZ(int) // required z
            .build();

    Returns:
      A new Vector3I builder